---
title: 'CSP: script-src'
slug: Web/HTTP/Headers/Content-Security-Policy/script-src
tags:
  - CSP
  - Content
  - Content-Security-Policy
  - Directive
  - HTTP
  - Reference
  - Script
  - Security
  - script-src
  - source
---
<div>{{HTTPSidebar}}</div>

<p>The HTTP {{HTTPHeader("Content-Security-Policy")}} (CSP) <code><strong>script-src</strong></code> directive specifies valid sources for JavaScript. This includes not only URLs loaded directly into {{HTMLElement("script")}} elements, but also things like inline script event handlers (<code>onclick</code>) and <a href="/en-US/docs/Web/XSLT">XSLT stylesheets</a> which can trigger script execution.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">CSP version</th>
   <td>1</td>
  </tr>
  <tr>
   <th scope="row">Directive type</th>
   <td>{{Glossary("Fetch directive")}}</td>
  </tr>
  <tr>
   <th scope="row">{{CSP("default-src")}} fallback</th>
   <td>Yes. If this directive is absent, the user agent will look for the <code>default-src</code> directive.</td>
  </tr>
 </tbody>
</table>

<h2 id="Syntax">Syntax</h2>

<p>One or more sources can be allowed for the <code>script-src</code> policy:</p>

<pre class="syntaxbox notranslate">Content-Security-Policy: script-src &lt;source&gt;;
Content-Security-Policy: script-src &lt;source&gt; &lt;source&gt;;
</pre>

<h3 id="Sources">Sources</h3>

<p>{{page("Web/HTTP/Headers/Content-Security-Policy/default-src", "Sources")}}</p>

<h2 id="Examples">Examples</h2>

<h3 id="Violation_case">Violation case</h3>

<p>Given this CSP header:</p>

<pre class="brush: bash notranslate">Content-Security-Policy: script-src https://example.com/</pre>

<p>the following script is blocked and won't be loaded or executed:</p>

<pre class="brush: html notranslate">&lt;script src="https://not-example.com/js/library.js"&gt;&lt;/script&gt;</pre>

<p>Note that inline event handlers are blocked as well:</p>

<pre class="brush: html notranslate">&lt;button id="btn" onclick="doSomething()"&gt;</pre>

<p>You should replace them with {{domxref("EventTarget.addEventListener", "addEventListener")}} calls:</p>

<pre class="brush: js notranslate">document.getElementById("btn").addEventListener('click', doSomething);</pre>

<h3 id="Unsafe_inline_script">Unsafe inline script</h3>

<div class="note">
<p><strong>Note:</strong> Disallowing inline styles and inline scripts is one of the biggest security wins CSP provides. However, if you absolutely have to use it, there are a few mechanisms that will allow them.</p>
</div>

<p>To allow inline scripts and inline event handlers, <code>'unsafe-inline'</code>, a nonce-source or a hash-source that matches the inline block can be specified.</p>

<pre class="brush: bash notranslate">Content-Security-Policy: script-src 'unsafe-inline';
</pre>

<p>The above Content Security Policy will allow inline {{HTMLElement("script")}} elements</p>

<pre class="brush: html notranslate">&lt;script&gt;
  var inline = 1;
&lt;/script&gt;</pre>

<p>You can use a nonce-source to only allow specific inline script blocks:</p>

<pre class="brush: bash notranslate">Content-Security-Policy: script-src 'nonce-2726c7f26c'</pre>

<p>You will have to set the same nonce on the {{HTMLElement("script")}} element:</p>

<pre class="brush: html notranslate">&lt;script nonce="2726c7f26c"&gt;
  var inline = 1;
&lt;/script&gt;</pre>

<p>Alternatively, you can create hashes from your inline scripts. CSP supports sha256, sha384 and sha512.</p>

<pre class="brush: bash notranslate">Content-Security-Policy: script-src 'sha256-B2yPHKaXnvFWtRChIbabYmUBFZdVfKKXHbWtWidDVF8='</pre>

<p>When generating the hash, don't include the {{HTMLElement("script")}} tags and note that capitalization and whitespace matter, including leading or trailing whitespace.</p>

<pre class="brush: html notranslate">&lt;script&gt;var inline = 1;&lt;/script&gt;</pre>

<h3 id="Unsafe_eval_expressions">Unsafe eval expressions</h3>

<p>The <code>'unsafe-eval'</code> source expression controls several script execution methods that create code from strings. If <code>'unsafe-eval'</code> isn't specified with the <code>script-src</code> directive, the following methods are blocked and won't have any effect:</p>

<ul>
 <li>{{jsxref("eval", "eval()")}}</li>
 <li>{{jsxref("Function", "Function()")}}</li>
 <li>When passing a string literal like to methods like: <code>window.setTimeout("alert(\"Hello World!\");", 500);</code>
  <ul>
   <li>{{domxref("window.setTimeout")}}</li>
   <li>{{domxref("window.setInterval")}}</li>
   <li>{{domxref("window.setImmediate")}}</li>
  </ul>
 </li>
 <li>{{domxref("window.execScript")}} {{non-standard_inline}} (IE &lt; 11 only)</li>
</ul>

<h3 id="strict-dynamic">strict-dynamic</h3>

<p>The <code>'strict-dynamic'</code> source expression specifies that the trust explicitly given to a script present in the markup, by accompanying it with a nonce or a hash, shall be propagated to all the scripts loaded by that root script. At the same time, any whitelist or source expressions such as <code>'self'</code> or <code>'unsafe-inline'</code> will be ignored. For example, a policy such as <code>script-src 'strict-dynamic' 'nonce-R4nd0m' https://whitelisted.com/</code> would allow loading of a root script with <code>&lt;script nonce="R4nd0m" src="https://example.com/loader.js"&gt;</code> and propagate that trust to any script loaded by <code>loader.js</code>, but disallow loading scripts from <code>https://whitelisted.com/</code> unless accompanied by a nonce or loaded from a trusted script.</p>

<pre class="brush: bash notranslate">script-src 'strict-dynamic' 'nonce-<em>someNonce</em>'</pre>

<p><em>Or</em></p>

<pre class="brush: bash notranslate">script-src 'strict-dynamic' 'sha256-<em>base64EncodedHash</em>'</pre>

<p>It is possible to deploy <code>strict-dynamic</code> in a backwards compatible way, without requiring user-agent sniffing.<br>
 The policy:</p>

<pre class="brush: bash notranslate">script-src 'unsafe-inline' https: 'nonce-abcdefg' 'strict-dynamic'</pre>

<p>will act like <code>'unsafe-inline' https:</code> in browsers that support CSP1, <code>https: 'nonce-abcdefg'</code> in browsers that support CSP2, and <code>'nonce-abcdefg' 'strict-dynamic'</code> in browsers that support CSP3.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{specName("CSP 3.0", "#directive-script-src", "script-src")}}</td>
   <td>{{Spec2('CSP 3.0')}}</td>
   <td>No changes.</td>
  </tr>
  <tr>
   <td>{{specName("CSP 1.1", "#directive-script-src", "script-src")}}</td>
   <td>{{Spec2('CSP 1.1')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("http.headers.csp.Content-Security-Policy.script-src")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{HTTPHeader("Content-Security-Policy")}}</li>
 <li>{{HTMLElement("script")}}</li>
 <li>{{CSP("script-src-elem")}}</li>
 <li>{{CSP("script-src-attr")}}</li>
</ul>
